function [TPtot_ss, TPEN_ss, TPE_ss, TPEN, TPE, TP, T, TT] = ma_eqn3(x, Ttot);

global KTT ktp_list KET KETN num_genes

Peq = x(1);
Neq = x(2);
Eeq = x(3);

T = zeros(1,num_genes);
TT = zeros(1,num_genes);
TP = zeros(1,num_genes);
TPE = zeros(1,num_genes);
TPEN = zeros(1,num_genes);

for j = 1:num_genes
    
    KTP = ktp_list(j);

    a = 2*KTT;
    b = (1 + Peq*KTP*(1 + Eeq*KET*(1 + Neq*KETN)));
    c = -Ttot(j);

    tempnum = -b + sqrt(b^2 - 4*a*c);
    if tempnum == 0
        fr4 = 4*a*c/(b^2);
        tempnum = b*(-fr4/2 - fr4^2/8 - (3*fr4^3)/48);
    end
    T(j) = tempnum/(2*a);  %ssDNA format

    TP(j) = T(j) * Peq * KTP;

    TPE(j) = KET*TP(j)*Eeq;
    TPEN(j) = KETN * Neq * TPE(j);
    
    TT(j) = T(j)^2 * KTT;
    
end



TPE_ss = sum(TPE);      % sum over all species of equilibrium amount of TPE
TPEN_ss = sum(TPEN);    % sum over all species of equilibrium amount of TPEN
TPtot_ss = sum(TP) + TPE_ss + TPEN_ss;     % sum over all species of total TP (which is equilbrium amount of TP from template-primer annealing equations
                        % but called total because total TP is then divided among free TP, TPE, and TPEN due to enzyme equilibrium equations)