num_gdna = length(gDNA_total_list);

det_frac = zeros(max_num_cycles+1,num_gdna);
det_acc_avg = zeros(max_num_cycles+1,num_gdna);
all_acc_avg = zeros(max_num_cycles+1,num_gdna);
frac_nuc_used = zeros(max_num_cycles+1,num_gdna);

rel_frac = zeros(max_num_cycles+1,num_genes,num_gdna);
amp_rate =  zeros(max_num_cycles,num_genes,num_gdna);
ampDNA_ind = zeros(max_num_cycles+1,num_genes,num_gdna);

    
for ngDNA = 1:num_gdna
    ngDNA
    gDNA_total = gDNA_total_list(ngDNA);

    det_frac_rp = zeros(num_repeats,max_num_cycles+1);
    det_acc_avg_rp = zeros(num_repeats,max_num_cycles+1);
    all_acc_avg_rp = zeros(num_repeats,max_num_cycles+1);
    frac_nuc_used_rp = zeros(num_repeats,max_num_cycles+1);

    rel_frac_all_rp = zeros(num_repeats,max_num_cycles+1,num_genes);
    amp_rate_rp = zeros(num_repeats,max_num_cycles,num_genes);
    ampDNA_ind_rp = zeros(num_repeats,max_num_cycles+1,num_genes);
    frac_per_species_all_rp = zeros(num_repeats,max_num_cycles+1,num_genes);

    for nrepeat = 1:num_repeats
    nrepeat
        gspDNA = zeros(num_genes,1);
        if use_species_ktp
            ktp_list = zeros(num_genes,1);
        else
            pcr_bias = zeros(num_genes,1);
        end
        det_limit = zeros(1,num_genes);

        distlist = [1:num_genes]';

        % defines the distribution of signal among species
        gspDNA_exponent = (distlist-1)*(gspDNA_init_range.^(1/dist_pow))/(num_genes-1);
        gspDNA = 10.^(gspDNA_exponent.^dist_pow);

        % scale up gsp so that it constitutes frac_gsp_of_total of total gDNA_total
        gspDNA_interim_total = sum(gspDNA);
        gspDNA_factor = gspDNA_interim_total/(gDNA_total * frac_gsp_of_total);
        gspDNA = gspDNA/gspDNA_factor;

        % convert from ng (basis for frac_gsp_of_total) to nmoles (basis for ma_eqn.m file)
        gspDNA_nmoles = gspDNA ./ (620*1500);

        num_pos = 1;
        lognorm_mu = log(1.0/exp(0.5*lognorm_sigma^2));
        while num_pos < num_genes+1
            ktp_list(num_pos) = KTP_mean * lognrnd(lognorm_mu,lognorm_sigma);
            if ktp_list(num_pos) > 0
                num_pos = num_pos + 1;
            end
        end

        num_pos = 1;
        while num_pos < num_genes+1
            det_limit(num_pos) = normrnd(det_limit_mean, det_limit_sd);
            if det_limit(num_pos) >= det_lim_min
                num_pos = num_pos + 1;
            end
        end

        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Actually perform the simulation!!!!!!!!!
        ampDNA_postpcr_expt_nmoles = ma_eqn(gspDNA_nmoles);   % nmoles
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

        % Organize and analyze the simulation results
        
        % convert back to ng
        ampDNA_postpcr_expt = ampDNA_postpcr_expt_nmoles .* 310 .* 1500; %ampDNA_postpcr_expt is in ssDNA format

        DNA_total_postpcr_expt = (1-frac_gsp_of_total).*gDNA_total + sum(ampDNA_postpcr_expt'); % raw vector of totals at each cycle
        DNA_total_postpcr_expt = DNA_total_postpcr_expt/2;        % purification loss
        temp_ampDNA_postpcr_expt = ampDNA_postpcr_expt/2;   % 2-d matrix, cycles in rows, species in columns

        DNA_postpcr_factor_expt = DNA_total_postpcr_expt/1500;     % scale up because always use 1.5 ug of total DNA for microarray analysis

        gspDNA_total = sum(gspDNA);
        frac_per_species_true_all = gspDNA/gspDNA_total;

        frac_per_species_expmt_detect = zeros(max_num_cycles+1,num_genes);
        frac_per_species_true_detect = zeros(max_num_cycles+1,num_genes);
        frac_per_species_expmt_all = zeros(max_num_cycles+1,num_genes);
        frac_per_species_all = zeros(max_num_cycles+1,num_genes);
        frac_per_species = zeros(max_num_cycles+1,num_genes);
        rel_frac_all = zeros(max_num_cycles+1,num_genes);
        det_accuracy_list = zeros(max_num_cycles+1,num_genes);
        all_accuracy_list = zeros(max_num_cycles+1,num_genes);
        amp_rate_each = zeros(max_num_cycles,num_genes);
        microarray_ampDNA_expt = zeros(max_num_cycles, num_genes);

        for ipc = 1:max_num_cycles+1
            microarray_ampDNA_expt(ipc,:) = temp_ampDNA_postpcr_expt(ipc,:)/DNA_postpcr_factor_expt(ipc);

            det_idx = find(microarray_ampDNA_expt(ipc,:) >= det_limit);
            num_detected(ipc) = size(det_idx,2);
            frac_of_species_detected(ipc) = num_detected(ipc)/num_genes;
            total_detected_on_array(ipc) = sum(microarray_ampDNA_expt(ipc,det_idx));    % total amount of DNA detected
            frac_per_species_expmt_detect(ipc,1:num_detected(ipc)) = microarray_ampDNA_expt(ipc,det_idx)/total_detected_on_array(ipc);   % fraction estimates per detected species, experimental
            total_orig_of_detected(ipc) = sum(gspDNA(det_idx));
            frac_per_species_true_detect(ipc,1:num_detected(ipc)) = gspDNA(det_idx)'/total_orig_of_detected(ipc);    % fraction estimate of detected species per all detected species, true (will add to 1)
            frac_per_species_expmt_all(ipc,det_idx) = frac_per_species_expmt_detect(ipc,1:num_detected(ipc));

            total_all(ipc) = sum(microarray_ampDNA_expt(ipc,:));
            frac_per_species_all(ipc,:) = microarray_ampDNA_expt(ipc,:) / total_all(ipc);
            % makes more sense to average relative fractions (current frac/initial frac) instead of absolute fractions
            rel_frac_all(ipc,:) = frac_per_species_all(ipc,:) ./ frac_per_species_all(1,:);

            % for this definition of accuracy, zero is best accuracy
            det_accuracy_list(ipc,1:num_detected(ipc)) = abs(frac_per_species_true_detect(ipc,1:num_detected(ipc)) - frac_per_species_expmt_detect(ipc,1:num_detected(ipc))) ./ frac_per_species_true_detect(ipc,1:num_detected(ipc));
            det_accuracy_avg(ipc) = mean(det_accuracy_list(ipc,1:num_detected(ipc)));

            all_accuracy_list(ipc,:) = abs(frac_per_species_true_all' - frac_per_species_expmt_all(ipc,:)) ./ frac_per_species_true_all';
            all_accuracy_avg(ipc) = mean(all_accuracy_list(ipc,:));

            acc_frac = frac_per_species_expmt_all(ipc,:) ./ frac_per_species_true_all';
            frac_within_factor_list = find(acc_frac < accuracy_factor & acc_frac > 1/accuracy_factor);
            genes_below_det_limit_list = find(acc_frac == 0 & frac_per_species_true_all' < det_limit ./ total_orig_of_detected(ipc));
            acc_factor_list = union(frac_within_factor_list, genes_below_det_limit_list);
            frac_acc(ipc) = length(acc_factor_list)/num_genes;
            frac_det_and_acc(ipc) = length(frac_within_factor_list)/num_genes;

            pears_corr_each(ipc) = corr(frac_per_species_true_all,frac_per_species_expmt_all(ipc,:)');

            rms_each(ipc) = sqrt(mean((frac_per_species_true_all' - frac_per_species_expmt_all(ipc,:)).^2));

            if ipc ~= 1;
                amp_rate_each(ipc-1,:) = ampDNA_postpcr_expt_nmoles(ipc,:) ./ ampDNA_postpcr_expt_nmoles(ipc-1,:);
            end
        end

        det_frac_rp(nrepeat,:) = frac_of_species_detected;
        rel_frac_all_rp(nrepeat,:,:) = rel_frac_all;
        det_acc_avg_rp(nrepeat,:) = det_accuracy_avg;
        all_acc_avg_rp(nrepeat,:) = all_accuracy_avg;
        fraction_acc_rp(nrepeat,:) = frac_acc;
        fraction_det_and_acc_rp(nrepeat,:) = frac_det_and_acc;
        pears_corr_rp(nrepeat,:) = pears_corr_each;
        rms_rp(nrepeat,:) = rms_each;
        amp_rate_rp(nrepeat,:,:) = amp_rate_each;

        num_expmts_to_combine_rp(nrepeat,:) = 1./DNA_postpcr_factor_expt;

        frac_nuc_used_rp(nrepeat,:) = 2*1500*sum(ampDNA_postpcr_expt_nmoles')/(init_nuc_total*2); 
        %1st factor of 2 takes into account double stranded DNA; 2nd factor of 2 - purification loss

        ampDNA_all_rp(nrepeat,:) = sum(ampDNA_postpcr_expt');
        ampDNA_ind_rp(nrepeat,:,:) = ampDNA_postpcr_expt;
        DNA_total_postpcr_expt_rp(nrepeat,:) = DNA_total_postpcr_expt;
        
        frac_per_species_all_rp(nrepeat,:,:) = frac_per_species_all;

    end

    if num_repeats > 1
        det_frac(:,ngDNA) = mean(det_frac_rp)';
        rel_frac(:,:,ngDNA) = squeeze(mean(rel_frac_all_rp));
        det_acc_avg(:,ngDNA) = mean(det_acc_avg_rp)';
        all_acc_avg(:,ngDNA) = mean(all_acc_avg_rp)';
        fraction_acc(:,ngDNA) = mean(fraction_acc_rp)';
        fraction_det_and_acc(:,ngDNA) = mean(fraction_det_and_acc_rp)';
        pears_corr(:,ngDNA) = mean(pears_corr_rp)';
        rms(:,ngDNA) = mean(rms_rp)';
        amp_rate(:,:,ngDNA) = squeeze(mean(amp_rate_rp));

        num_expmts_to_combine(:,ngDNA) = mean(num_expmts_to_combine_rp)';

        frac_nuc_used(:,ngDNA) = mean(frac_nuc_used_rp)';

        ampDNA_all(:,ngDNA) = mean(ampDNA_all_rp);
        ampDNA_ind(:,:,ngDNA) = mean(ampDNA_ind_rp);
        DNA_total_postpcr_expt_all(:,ngDNA)= mean(DNA_total_postpcr_expt_rp);
        
        frac_per_species(:,:,ngDNA) = squeeze(mean(frac_per_species_all_rp));

    else
        det_frac(:,ngDNA) = det_frac_rp';
        rel_frac(:,:,ngDNA) = squeeze(rel_frac_all_rp);
        det_acc_avg(:,ngDNA) = det_acc_avg_rp';
        all_acc_avg(:,ngDNA) = all_acc_avg_rp';
        fraction_acc(:,ngDNA) = fraction_acc_rp';
        fraction_det_and_acc(:,ngDNA) = fraction_det_and_acc_rp';
        pears_corr(:,ngDNA) = pears_corr_rp';
        rms(:,ngDNA) = rms_rp';
        amp_rate(:,:,ngDNA) = squeeze(amp_rate_rp);

        num_expmts_to_combine(:,ngDNA) = num_expmts_to_combine_rp';

        frac_nuc_used(:,ngDNA) = frac_nuc_used_rp';

        ampDNA_all(:,ngDNA) = ampDNA_all_rp;
        ampDNA_ind(:,:,ngDNA) = ampDNA_ind_rp;
        DNA_total_postpcr_expt_all(:,ngDNA)= DNA_total_postpcr_expt_rp;
        
        frac_per_species(:,:,ngDNA) = squeeze(frac_per_species_all_rp);
    end

end

amp_mean = squeeze(mean(amp_rate,2));
% lines below are method used to calculate pcr bias sd
amp_rps_mean = mean(amp_rate_rp,3);                 % gives numrepeats x numcycles
amprate_rps_avg = mean(amp_rps_mean(:,10:20),2);    % nr

amprate_rps_100_10to20 = amp_rate_rp(:,10:20,:);    % nr x 11 x numspecies
amprate_rps_species = mean(amprate_rps_100_10to20,2);   % nr x numspecies

arabsvariance_rps = [];
for iamprate = 1:num_repeats
    arabsvariance_rps(iamprate) = median(abs(amprate_rps_species(iamprate,:) - amprate_rps_avg(iamprate))) * 100 / amprate_rps_avg(iamprate);
end

arabsvariance = mean(arabsvariance_rps);

